SystemOrganization addCategory: #GhostProxiesTests!
SystemOrganization addCategory: #'GhostProxiesTests-Mocks'!

Object subclass: #GHUser
	instanceVariableNames: 'username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests-Mocks'!

!GHUser class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:06'!
named: aName
	^ self new username: aName! !

!GHUser methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 12:05'!
username ^ username! !

!GHUser methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 11:07'!
username: anObject
	username := anObject! !

GHUser subclass: #GHUserSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests-Mocks'!

TestCase subclass: #GHSimpleForwarderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests'!

!GHSimpleForwarderTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 2/9/2012 16:04'!
setUp
	GHProxyTrap initialize.   
	FileDirectory default deleteFileNamed:  'GhostLog.txt'.
	GHGhostLogger changeToFileLogger ! !

!GHSimpleForwarderTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 2/9/2012 14:59'!
testSimpleForwardingForClassesToClass
    | aProxy aUser |
       aUser := GHUser named: 'Kurt'.
	[aProxy := GHClassProxy createProxyAndReplace: GHUser handler: GHSimpleForwarderProxyHandler new. 
       self assert:  GHUser name equals: #GHUser. 
	] ensure: [ aProxy uninstall ]! !

!GHSimpleForwarderTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 2/9/2012 14:53'!
testSimpleForwardingForClassesToInstance
    | aProxy aUser |
       aUser := GHUser named: 'Kurt'.
       
	[ aProxy := GHClassProxy createProxyAndReplace: GHUser handler: GHSimpleForwarderProxyHandler new. 
     self assert: aUser username equals: 'Kurt'.
	] ensure: [ aProxy uninstall ]! !

!GHSimpleForwarderTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 2/9/2012 15:58'!
testSimpleForwardingForClassesToSubclass
    | aProxy aUser |
       aUser := GHUser named: 'Kurt'.
	[aProxy := GHClassProxy createProxyAndReplace: GHUser handler: GHSimpleForwarderProxyHandler new. 
	self assert:  GHUserSubclass name equals: #GHUserSubclass. 
	] ensure: [ aProxy uninstall ]! !

!GHSimpleForwarderTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 2/9/2012 16:04'!
testSimpleForwardingForClassesToSubclassInstance
    | aProxy aUser |
       aUser := GHUserSubclass named: 'Kurt'.
	[ aProxy := GHClassProxy createProxyAndReplace: GHUser handler: GHSimpleForwarderProxyHandler new. 
     self assert: aUser username equals: 'Kurt'.
	] ensure: [ aProxy uninstall ]! !

!GHSimpleForwarderTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 2/9/2012 14:59'!
testSimpleForwardingForMethodUsingBecome
       | aProxy aUser method |
       aUser := GHUser named: 'Kurt'.
       method := GHUser methodDict at: #username.
       [aProxy := GHProxy createProxyAndReplace: method handler: GHSimpleForwarderProxyHandler new. 
       self assert: aProxy getSource equals: 'username ^ username'. 
       self assert: aUser username equals: 'Kurt'.
	 ] ensure: [ aProxy uninstall ]! !

!GHSimpleForwarderTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 2/9/2012 11:00'!
testSimpleForwardingForRegularObject
	| proxy |
	proxy := GHProxy createProxyFor: (Point x: 3 y: 4) handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy x equals: 3. 
	self assert: proxy y equals: 4.! !

!GHSimpleForwarderTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 2/9/2012 11:00'!
testSimpleForwardingForRegularObject2
	| proxy |
	proxy := GHProxy createProxyFor: (GHUser named: 'mariano') handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy username = 'mariano'.! !

!GHSimpleForwarderTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 2/9/2012 11:52'!
testSimpleForwardingForRegularObjectWithBecome
	| proxy |
	proxy := GHProxy createProxyAndReplace: (Point x: 3 y: 4) handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy x equals: 3. 
	self assert: proxy y equals: 4.! !
